Codeforces--333C--The Two Routes(最短路弗洛伊德)(思维)

来源:互联网 发布:大数据技术 原理 编辑:程序博客网 时间:2024/05/23 14:32
The Two Routes
Time Limit: 2000MS Memory Limit: 262144KB 64bit IO Format: %I64d & %I64u

Submit Status

Description

In Absurdistan, there are n towns (numbered 1 through n) and m bidirectional railways. There is also an absurdly simple road network — for each pair of different towns x and y, there is a bidirectional road between towns x and yif and only if there is no railway between them. Travelling to a different town using one railway or one road always takes exactly one hour.

A train and a bus leave town 1 at the same time. They both have the same destination, town n, and don't make any stops on the way (but they can wait in town n). The train can move only along railways and the bus can move only along roads.

You've been asked to plan out routes for the vehicles; each route can use any road/railway multiple times. One of the most important aspects to consider is safety — in order to avoid accidents at railway crossings, the train and the bus must not arrive at the same town (except town n) simultaneously.

Under these constraints, what is the minimum number of hours needed for both vehicles to reach town n (the maximum of arrival times of the bus and the train)? Note, that bus and train are not required to arrive to the town n at the same moment of time, but are allowed to do so.

Input

The first line of the input contains two integers n and m (2 ≤ n ≤ 4000 ≤ m ≤ n(n - 1) / 2) — the number of towns and the number of railways respectively.

Each of the next m lines contains two integers u and v, denoting a railway between towns u and v (1 ≤ u, v ≤ nu ≠ v).

You may assume that there is at most one railway connecting any two towns.

Output

Output one integer — the smallest possible time of the later vehicle's arrival in town n. If it's impossible for at least one of the vehicles to reach town n, output  - 1.

Sample Input

Input
4 21 33 4
Output
2
Input
4 61 21 31 42 32 43 4
Output
-1
Input
5 54 23 54 55 11 2
Output
3

Hint

In the first sample, the train can take the route  and the bus can take the route . Note that they can arrive at town 4 at the same time.

In the second sample, Absurdistan is ruled by railwaymen. There are no roads, so there's no way for the bus to reach town 4.


题意:有n个城市,城市之间有m条铁路,剩下的都是公路,加起来是一个完全图,因为安全的问题,火车汽车不能在一个车站,除了n,现在要求一个时间,一个可以让火车还有汽车同时从1到达n的时间
思路:额,乍一看优点懵逼,但是如果把铁路还有公路放在两个图中那就简单很多了,就是一个最短路,因为点的个数很少,所以弗洛伊德就可以搞定,如果铁路或者公路有一个不能到达,那就输出-1,否则输出最大值
#include<cstdio>#include<cstring>#include<algorithm>using namespace std;#define INF 0x3f3f3f3fint n,m,map1[1010][1010],map2[1010][1010];int main(){while(scanf("%d%d",&n,&m)!=EOF){for(int i=1;i<=n;i++)for(int j=1;j<=n;j++){map1[i][j]=map1[j][i]=INF;map2[i][j]=map2[j][i]=1;}int x,y;for(int i=0;i<m;i++){scanf("%d%d",&x,&y);map1[x][y]=map1[y][x]=1;map2[x][y]=map2[y][x]=INF;}for(int k=1;k<=n;k++)for(int i=1;i<=n;i++)for(int j=1;j<=n;j++)map1[i][j]=min(map1[i][j],map1[i][k]+map1[k][j]);for(int k=1;k<=n;k++)for(int i=1;i<=n;i++)for(int j=1;j<=n;j++)map2[i][j]=min(map2[i][j],map2[i][k]+map2[k][j]);if(map1[1][n]>=INF||map2[1][n]>=INF)printf("-1\n");else{int maxx=max(map1[1][n],map2[1][n]);printf("%d\n",maxx);}}return 0;}


0 0
原创粉丝点击